package it.unisannio.ding.ids.wedroid.app.view;

import android.content.Intent;
import android.os.Bundle;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import java.util.List;
import java.util.Objects;

import it.unisannio.ding.ids.wedroid.app.R;
import it.unisannio.ding.ids.wedroid.app.data.entity.WList;
import it.unisannio.ding.ids.wedroid.app.util.PreferenceReader;
import it.unisannio.ding.ids.wedroid.app.util.SharedPreferenceHelper;
import it.unisannio.ding.ids.wedroid.app.view.adapter.WListsAdapter;
import it.unisannio.ding.ids.wedroid.app.viewModel.WListsListViewModel;

public class WListsListActivity extends AppCompatActivity {

    Toolbar myToolbar;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_wlists_view);
        myToolbar = findViewById(R.id.my_toolbar);
        setSupportActionBar(myToolbar);
        Intent i = getIntent();

        String boardTitle = i.getStringExtra("barTitle");
        Objects.requireNonNull(getSupportActionBar()).setTitle(boardTitle);
        int barColor = i.getIntExtra("barColor", 0);
        myToolbar.setBackgroundColor(barColor);

        PreferenceReader reader =new SharedPreferenceHelper(this);

        RecyclerView recyclerView = findViewById(R.id.recyclerviewWList);
        final WListsAdapter adapter = new WListsAdapter(this);
        recyclerView.setAdapter(adapter);
        recyclerView.setLayoutManager(new LinearLayoutManager(this,
                LinearLayoutManager.HORIZONTAL, false));
        //linearLayoutManager.setOrientation(LinearLayoutManager.VERTICAL);
        //recyclerView.setHasFixedSize(true);

        WListsListViewModel viewModel = new ViewModelProvider(this).get(WListsListViewModel.class);

        viewModel.getAllWLists().observe(this, new Observer<List<WList>>() {
            @Override
            public void onChanged(List<WList> wLists) {
                adapter.setWLists(wLists);
            }
        });
    }
}
